package com.example.mountaintravel.util;

import java.util.HashMap;
import java.util.Map;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import Decoder.BASE64Decoder;
import Decoder.BASE64Encoder;




/**
 * @ClassName: AesTerminalUtil 
 * @Description: TODO(android Ios 和系统交互 的 AES交互加解密) 
 *  
 */

/**
 * AES 是一种可逆加密算法，对用户的敏感信息加密处理 对原始数据进行AES加密后，在进行Base64编码转化；                                                                                                                                                                                                              
 */
public class AesTerminalUtil {

    /*
     * 加密用的Key 可以用26个字母和数字组成 此处使用AES-128-CBC加密模式，key需要为16位。
     */
    //private static String sKey = "smkldospdosldaaa";//key，key需要为16位 可自行修改
    private static String sKey = "swop0531vrz6903g";//key，key需要为16位 可自行修改
    private static String ivParameter = "0392039203920300";//偏移量,可自行修改
    private static AesTerminalUtil instance = null;

    private AesTerminalUtil() {

    }

    public static AesTerminalUtil getInstance() {
        if (instance == null)
            instance = new AesTerminalUtil();
        return instance;
    }
    
    public static String Encrypt(String encData ,String secretKey,String vector) throws Exception {
        
        if(secretKey == null) {
            return null;
        }
        if(secretKey.length() != 16) {
            return null;
        }
        Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
        byte[] raw = secretKey.getBytes();
        SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
        IvParameterSpec iv = new IvParameterSpec(vector.getBytes());// 使用CBC模式，需要一个向量iv，可增加加密算法的强度
        cipher.init(Cipher.ENCRYPT_MODE, skeySpec, iv);
        byte[] encrypted = cipher.doFinal(encData.getBytes("utf-8"));
        return new BASE64Encoder().encode(encrypted);// 此处使用BASE64做转码。
    }


    // 加密
    public static String encrypt(String sSrc) throws Exception {
        Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
        byte[] raw = sKey.getBytes();
        SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
        IvParameterSpec iv = new IvParameterSpec(ivParameter.getBytes());// 使用CBC模式，需要一个向量iv，可增加加密算法的强度
        cipher.init(Cipher.ENCRYPT_MODE, skeySpec, iv);
        byte[] encrypted = cipher.doFinal(sSrc.getBytes("utf-8"));
        return new BASE64Encoder().encode(encrypted);// 此处使用BASE64做转码。
    }

    // 解密
    public static String decrypt(String sSrc) throws Exception {
        try {
            byte[] raw = sKey.getBytes("ASCII");
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            IvParameterSpec iv = new IvParameterSpec(ivParameter.getBytes());
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, iv);
            byte[] encrypted1 = new BASE64Decoder().decodeBuffer(sSrc);// 先用base64解密
            byte[] original = cipher.doFinal(encrypted1);
            String originalString = new String(original, "utf-8");
            return originalString;
        } catch (Exception ex) {
            return null;
        }
    }
    
    public static String decrypt(String sSrc,String key,String ivs) throws Exception {
        try {
            byte[] raw = key.getBytes("ASCII");
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            IvParameterSpec iv = new IvParameterSpec(ivs.getBytes());
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, iv);
            byte[] encrypted1 = new BASE64Decoder().decodeBuffer(sSrc);// 先用base64解密
            byte[] original = cipher.doFinal(encrypted1);
            String originalString = new String(original, "utf-8");
            return originalString;
        } catch (Exception ex) {
            return null;
        }
    }
    
    public static String encodeBytes(byte[] bytes) {
        StringBuffer strBuf = new StringBuffer();

        for (int i = 0; i < bytes.length; i++) {
            strBuf.append((char) (((bytes[i] >> 4) & 0xF) + ((int) 'a')));
            strBuf.append((char) (((bytes[i]) & 0xF) + ((int) 'a')));
        }

        return strBuf.toString();
    }
    
    //使用案例
//    public static void main(String[] args) throws Exception {
    
//        // 需要加密的字串
//        String cSrc = "[{\"request_no\":\"1001\",\"service_code\":\"FS0001\"}]";
//        
//        // 加密
//        long lStart = System.currentTimeMillis();
//        //String enString = AesTerminalUtil.getInstance().encrypt(cSrc);
//        String enString = AesTerminalUtil.encrypt(cSrc);
//        System.out.println("加密后的字串是：" + enString);
//
//        long lUseTime = System.currentTimeMillis() - lStart;
//        System.out.println("加密耗时：" + lUseTime + "毫秒");
    
//        // 解密
//        lStart = System.currentTimeMillis();
//        String DeString = AesTerminalUtil.getInstance().decrypt(enString);
//        System.out.println("解密后的字串是：" + DeString);
//        lUseTime = System.currentTimeMillis() - lStart;
//        System.out.println("解密耗时：" + lUseTime + "毫秒");
//    }
    
    public static  Map<String,Object> gtsApiAesDecryptToMap(String sesskey){
		
		Map<String,Object> map = new HashMap<String,Object>();
		String sesskeyStr = "";
		
		if(sesskey != null && !sesskey .equals("")){
			try {
				//此处 注意格式 要把 空格变成+号 等号 不能变 否则解密会出错
				sesskey = sesskey.replaceAll(" ", "+");
				sesskeyStr = decrypt(sesskey, "3201olxeucjdwc45", "0392039203920300");
			} catch (Exception e) {
				e.printStackTrace();
				sesskeyStr = "";
			}
		}else{
			sesskeyStr = "";
		}
		
		if(sesskeyStr != "" && sesskeyStr != null){
			map = MapAndStringUtil.stringToMap(sesskeyStr);
		}else{
			map = null;
		}
		
		return map;
	}

}